using System;
using System.Collections.Generic;
using System.Collections;
using SdlDotNet;

namespace Physics.Config.Files
{
    class Creator_cfg : ConfigFile
    {
        private String readFile = "Creator.cfg";

        private InputSet perframekey = new InputSet(Key.LeftControl);

        private InputSet addBall1key = new InputSet(Key.One);
        private InputSet addBall2key = new InputSet(Key.Two);
        private InputSet removeBallkey = new InputSet(Key.Three);
        private InputSet removeAllBallskey = new InputSet(Key.Four);

        private InputSet removePolykey = new InputSet(Key.Nine);
        private InputSet removeAllPolyskey = new InputSet(Key.Zero);

        private InputSet printNumBallskey = new InputSet(Key.N);
        private InputSet addWindParticleskey = new InputSet(Key.Minus);

        private InputSet addPointkey = new InputSet(MouseButton.PrimaryButton);
        private InputSet removePointkey = new InputSet(MouseButton.SecondaryButton);

        private Hashtable map;

        public Creator_cfg()
        {
            List<ConfigEntry> lst = Read(configFolder + readFile);

            CreateStringToKeyMap();
            
            foreach (ConfigEntry cfge in lst)
            {
                if (map.ContainsKey(cfge.Varible))
                    ((InputSet)map[cfge.Varible]).SetTo(cfge.Keys);
            }
        }

        public bool addBall1()
        {
            return addBall1key.wasPressed() ||
                addBall1key.isPressed() && perframekey.isPressed();
        }
        public bool addBall2()
        {
            return addBall2key.wasPressed() ||
                addBall2key.isPressed() && perframekey.isPressed();
        }
        public bool removeBall()
        {
            return removeBallkey.wasPressed() ||
                removeBallkey.isPressed() && perframekey.isPressed();
        }
        public InputSet removeAllBalls
        { get { return removeAllBallskey; } }

        public bool removePoly()
        {
            return removePolykey.wasPressed() ||
                removePolykey.isPressed() && perframekey.isPressed();
        }
        public InputSet removeAllPolys
        { get { return removeAllPolyskey; } }

        public InputSet printNumBalls
        { get { return printNumBallskey; } }
        public InputSet addWindParticles
        { get { return addWindParticleskey; } }

        public bool addPoint()
        {
            return addPointkey.wasPressed() ||
                addPointkey.isPressed() && perframekey.isPressed();
        }
        public bool removePoint()
        {
            return removePointkey.wasPressed() ||
                removePointkey.isPressed() && perframekey.isPressed();
        }


        private void CreateStringToKeyMap()
        {
            if (map != null)
                return;

            map = new Hashtable();

            map.Add("perframe", perframekey);

            map.Add("addBall1", addBall1key);
            map.Add("addBall2", addBall2key);
            map.Add("removeBall", removeBallkey);
            map.Add("removeAllBalls", removeAllBallskey);

            map.Add("removePoly", removePolykey);
            map.Add("removeAllPolys", removeAllPolyskey);

            map.Add("printNumBalls", printNumBallskey);
            map.Add("addWindP", addWindParticleskey);
            map.Add("addWindParticles", addWindParticleskey);

            map.Add("addPoint", addPointkey);
            map.Add("removePoint", removePointkey);
        }
    }
}
