using System;
using System.Collections.Generic;
using System.Collections;
using SdlDotNet;

namespace Physics.Config.Files
{
    class Debugger_cfg : ConfigFile
    {
        private String readFile = "Debugger.cfg";

        private InputSet fpskey = new InputSet(Key.Comma);
        private InputSet collInfokey = new InputSet(Key.Period);
        private InputSet clearParticleskey = new InputSet(Key.X);

        private InputSet showGridskey = new InputSet(Key.M);
        private InputSet oldCollkey = new InputSet(Key.B);
        private InputSet futureCollkey = new InputSet(Key.H);

        private Hashtable map;

        public Debugger_cfg()
        {
            List<ConfigEntry> lst = Read(configFolder + readFile);

            CreateStringToKeyMap();

            foreach (ConfigEntry cfge in lst)
            {
                if (map.ContainsKey(cfge.Varible))
                    ((InputSet)map[cfge.Varible]).SetTo(cfge.Keys);
            }
        }

        public InputSet fps
        { get { return fpskey; } }
        public InputSet collInfo
        { get { return collInfokey; } }
        public InputSet clearParticles
        { get { return clearParticleskey; } }

        public InputSet showGrids
        { get { return showGridskey; } }
        public InputSet oldColl
        { get { return oldCollkey; } }
        public InputSet futureColl
        { get { return futureCollkey; } }

        private void CreateStringToKeyMap()
        {
            if (map != null)
                return;

            map = new Hashtable();

            map.Add("fps", fpskey);
            map.Add("collInfo", collInfokey);
            map.Add("clearParticles", clearParticleskey);

            map.Add("showGrids", showGridskey);
            map.Add("oldColl", oldCollkey);
            map.Add("futureColl", futureCollkey);
        }
    }
}
