using System;
using System.Collections.Generic;
using System.Collections;
using SdlDotNet;

namespace Physics.Config.Files
{
    class Global_cfg : ConfigFile
    {
        private String readFile = "Global.cfg";

        private InputSet exitkey = new InputSet(Key.Escape);

        private Hashtable map;

        public Global_cfg()
        {
            List<ConfigEntry> lst = Read(configFolder + readFile);

            CreateStringToKeyMap();

            foreach (ConfigEntry cfge in lst)
            {
                if (map.ContainsKey(cfge.Varible))
                    ((InputSet)map[cfge.Varible]).SetTo(cfge.Keys);
            }
        }

        public InputSet exit
        { get { return exitkey; } }

        private void CreateStringToKeyMap()
        {
            if (map != null)
                return;

            map = new Hashtable();

            map.Add("exit", exitkey);
        }
    }
}
