using System;
using System.Collections.Generic;
using System.Collections;
using SdlDotNet;

namespace Physics.Config.Files
{
    class Player_cfg : ConfigFile
    {
        private String readFile = "Player.cfg";

        private InputSet upkey = new InputSet(Key.W);
        private InputSet downkey = new InputSet(Key.S);
        private InputSet leftkey = new InputSet(Key.A);
        private InputSet rightkey = new InputSet(Key.D);

        private InputSet aClockWisekey = new InputSet(Key.Q);
        private InputSet clockWisekey = new InputSet(Key.E);

        private InputSet magnetkey = new InputSet(Key.Space);

        private Hashtable map;

        public Player_cfg()
        {
            List<ConfigEntry> lst = Read(configFolder + readFile);

            CreateStringToKeyMap();

            foreach (ConfigEntry cfge in lst)
            {
                if (map.ContainsKey(cfge.Varible))
                    ((InputSet)map[cfge.Varible]).SetTo(cfge.Keys);
            }
        }

        public InputSet up
        { get { return upkey; } }
        public InputSet down
        { get { return downkey; } }
        public InputSet left
        { get { return leftkey; } }
        public InputSet right
        { get { return rightkey; } }

        public InputSet aClockWise
        { get { return aClockWisekey; } }
        public InputSet clockWise
        { get { return clockWisekey; } }

        public InputSet magnet
        { get { return magnetkey; } }

        private void CreateStringToKeyMap()
        {
            if (map != null)
                return;

            map = new Hashtable();

            map.Add("up", upkey);
            map.Add("down", downkey);
            map.Add("left", leftkey);
            map.Add("right", rightkey);

            map.Add("aClockWise", aClockWisekey);
            map.Add("clockWise", clockWisekey);

            map.Add("magnet", magnetkey);
        }
    }
}
