using System;
using System.Collections.Generic;
using System.Collections;
using SdlDotNet;

namespace Physics.Config.Files
{
    class States_cfg : ConfigFile
    {
        private String readFile = "States.cfg";

        private InputSet pausekey = new InputSet(Key.P);
        private InputSet createPolykey = new InputSet(Key.C);

        private Hashtable map;

        public States_cfg()
        {
            List<ConfigEntry> lst = Read(configFolder + readFile);

            CreateStringToKeyMap();

            foreach (ConfigEntry cfge in lst)
            {
                if (map.ContainsKey(cfge.Varible))
                    ((InputSet)map[cfge.Varible]).SetTo(cfge.Keys);
            }
        }

        public InputSet pause
        { get { return pausekey; } }
        public InputSet createPoly
        { get { return createPolykey; } }

        private void CreateStringToKeyMap()
        {
            if (map != null)
                return;

            map = new Hashtable();

            map.Add("pause", pausekey);
            map.Add("createPoly", createPolykey);
        }
    }
}
