using System;
using System.Collections.Generic;
using System.Text;

using Physics.Entities;
using Physics.Entities.Physics;

namespace Physics
{
    class MouseAccel : PhysicsEffect
    {
        public Vector2 fromPosition
        {
            get
            {
                return from.Clone();
            }
        }

        Vector2 from;
        Vector2 to;

        public MouseAccel(Vector2 fromPosition)
        {
            from = fromPosition.Clone();
        }

        public void UpdateTo(Vector2 toPosition)
        {
            to = toPosition.Clone();
        }

        public void ApplyEffect(PhysicsE E)
        {
            if (E.affectedby.MouseAccel && !E.affectedby.Ignored(this))
            {
                Vector2 mouseWorldForce = to - from;
                mouseWorldForce /= 2000;

                E.ApplyForce(mouseWorldForce * E.Mass);
            }
        }

        public void ApplyEffect(Entity E)
        {
            if (E is PhysicsE)
                ApplyEffect((PhysicsE)E);
        }
    }
}
