using System;
using System.Collections.Generic;
using SdlDotNet;

namespace Physics.Entities.Particles
{
    abstract class ParticleE : Entity
    {
        // a Particle also needs a time of death
        private long deathTime;
        private long birthTime;

        public bool isDead;
        private bool canDie;

        public ParticleE(Vector2 position, bool canDie)
        {
            Position = position.Clone();
            birthTime = Game.TickCount;
            deathTime = birthTime;
            this.canDie = canDie;
        }
        public ParticleE(Vector2 position, int lifeTime)
        {
            Position = position.Clone();

            birthTime = Game.TickCount;
            deathTime = birthTime + lifeTime;
			this.canDie = true;
        }

        public override void Update(float timeStep)
        {
            if (canDie)
            {
                long time = Game.TickCount;
                isDead = time > birthTime && deathTime <= time;
            }

            Position += Velo;
        }
    }
}
