using System;
using System.Collections.Generic;
using System.Drawing;
using SdlDotNet;

namespace Physics.Entities.Particles
{
    class PointP : ParticleE
    {
        private Circle circle;

        public short radius;
        public Color color = Color.Green;

        public PointP(Vector2 position, int lifeTime)
            : base(position,lifeTime)
        {
            radius = 2;
        }

        public override void Update(float timeStep)
        {
            base.Update(timeStep);
            circle = new Circle(Position.Point, radius);
        }

        public override void Draw(SdlDotNet.Surface target)
        {
            if (radius == 0)
                target.DrawPixel((int)Position.X, (int)Position.Y, color);
            else
                target.DrawFilledCircle(circle, color);
        }
    }
}
