using System;
using System.Drawing;
using SdlDotNet;
using Physics.Config.Files;

namespace Physics.Entities.Physics
{
    class Player : Ball
    {
        // values for moving the Player by key input
        public float keyForce = 0.1F;
        public float keyTorque = 5F;

        private Player_cfg cfg;

        private GravityWell well;

        public Player(Vector2 Position) : base(Position) 
        {
            cfg = new Player_cfg();
        }

        public void Input()
        {
            if (cfg.up.isPressed())
                Force.Y -= keyForce; // move up

            if (cfg.down.isPressed())
                Force.Y += keyForce; // move down

            if (cfg.left.isPressed())
                Force.X -= keyForce; // move left

            if (cfg.right.isPressed())
                Force.X += keyForce; // move right

            if (cfg.aClockWise.isPressed())
                Torque += keyTorque; // turn conter-clockwise

            if (cfg.clockWise.isPressed())
                Torque -= keyTorque; // turn clockwise

            
            // manige the gravity well at players location
            if (cfg.magnet.wasPressed())
            {
                well = new GravityWell(Position);
                affectedby.AddIgnore(well);
                EffectsManager.Add(well);

                //HACK
                //StaticCollisions = true;
                keyForce *= 50;
                Mass *= 50;
            }
            if (cfg.magnet.isPressed())
            {
                EffectsManager.Remove(well);
                affectedby.RemoveIgnore(well);
                well = new GravityWell(Position);
                affectedby.AddIgnore(well);
                EffectsManager.Add(well);
            }
            else if (cfg.magnet.wasReleased())
            {
                EffectsManager.Remove(well);
                affectedby.RemoveIgnore(well);
                well = null;

                //HACK
                //StaticCollisions = false;
                keyForce /= 50;
                Mass /=  50;
            }
        }
    }
}
